"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MutableString = /** @class */ (function () {
    function MutableString(value) {
        this.value = value;
    }
    MutableString.empty = function () {
        return new MutableString("");
    };
    MutableString.of = function (value) {
        return new MutableString(value);
    };
    MutableString.prototype.append = function (postfix) {
        this.value = this.value + postfix;
    };
    MutableString.prototype.prepend = function (prefix) {
        this.value = prefix + this.value;
    };
    MutableString.prototype.concat = function (other) {
        this.append(other.getValue());
        return this;
    };
    MutableString.prototype.getValue = function () {
        return this.value;
    };
    return MutableString;
}());
exports.MutableString = MutableString;
var MutableNumber = /** @class */ (function () {
    function MutableNumber(inputs, total) {
        this.inputs = inputs;
        this.total = total;
    }
    MutableNumber.empty = function () {
        return new MutableNumber([], 0);
    };
    MutableNumber.prototype.add = function (value) {
        this.total = this.total + value;
        this.inputs.push(value);
    };
    MutableNumber.prototype.addTogether = function (other) {
        var newInputs = this.inputs.concat(other.getInputs());
        var newTotal = this.total + this.getTotal();
        return new MutableNumber(newInputs, newTotal);
    };
    MutableNumber.prototype.getInputs = function () {
        return this.inputs.slice();
    };
    MutableNumber.prototype.getTotal = function () {
        return this.total;
    };
    MutableNumber.prototype.getInputCount = function () {
        return this.inputs.length;
    };
    return MutableNumber;
}());
exports.MutableNumber = MutableNumber;
